package com.qmth.distributed.print.business.templete.execute;

import com.alibaba.excel.ExcelReader;
import com.alibaba.excel.support.ExcelTypeEnum;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.qmth.distributed.print.business.bean.dto.FieldsDto;
import com.qmth.distributed.print.business.entity.ExamPrintPlan;
import com.qmth.distributed.print.business.entity.TBTask;
import com.qmth.distributed.print.business.enums.TaskStatusEnum;
import com.qmth.distributed.print.business.service.ExamDetailService;
import com.qmth.distributed.print.business.service.ExamPrintPlanService;
import com.qmth.distributed.print.business.templete.excelListener.ExaminationListener;
import com.qmth.distributed.print.business.templete.importData.AsyncImportTaskTemplete;
import com.qmth.distributed.print.common.contant.SystemConstant;
import com.qmth.distributed.print.common.enums.ExceptionResultEnum;
import com.qmth.distributed.print.common.util.Result;
import org.omg.CORBA.OBJ_ADAPTER;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.io.IOException;
import java.io.InputStream;
import java.text.MessageFormat;
import java.util.List;
import java.util.Map;
import java.util.StringJoiner;
import java.util.stream.Collectors;

/**
 * @Description: 考务数据导入模板
 * @Author: CaoZixuan
 * @Date: 2021-04-07
 */
@Service
public class AsyncExaminationImportTemplateService extends AsyncImportTaskTemplete {
    @Resource
    private ExamDetailService examDetailService;
    @Resource
    private ExamPrintPlanService examPrintPlanService;

    public static final String OBJ_TITLE = "考务数据";

    @Transactional(rollbackFor = Exception.class)
    @Override
    public Result importTask(Map<String, Object> map) throws IOException {
        TBTask tbTask = (TBTask) map.get(SystemConstant.TASK);
        System.out.println("printPlanId = " + tbTask.getPrintPlanId());
        System.out.println("------开始----------");
        InputStream inputStream = super.getUploadFileInputStream(tbTask);
        System.out.println("------结束----------");
        StringJoiner stringJoinerSummary = new StringJoiner("\n")
                .add(MessageFormat.format("{0}{1}{2}", FORMAT_TIME, BEGIN_TITLE, OBJ_TITLE));
        tbTask.setStatus(TaskStatusEnum.RUNNING);
        // try

            String importFilePath = tbTask.getImportFilePath();
            Map importFilePathMap = JSONObject.parseObject(importFilePath);
            String path = String.valueOf(importFilePathMap.get("path"));
            System.out.println("path = " + path);
//            // 该学校有效考务数据
//            List<FieldsDto> fieldsDtoList = examDetailService.findExaminationFields(tbTask.getSchoolId());
//            if (fieldsDtoList.size() == 0){
//                throw ExceptionResultEnum.ERROR.exception("该学校没有设置考务数据");
//            }
//            for (FieldsDto fieldsDto : fieldsDtoList) {
//                if (!headerList.contains(fieldsDto.getName())){
//                    System.out.println("exception " + fieldsDto.getName());
//                    throw ExceptionResultEnum.ERROR.exception("学校考务必填字段 ：'" + fieldsDto.getName() + "' 不存在");
//                }
//            }
//            for (FieldsDto fieldsDto : fieldsDtoList) {
//                String name = fieldsDto.getName();
//                String code = fieldsDto.getCode();
//                for (int i = 0;i < headerList.size();i++){
//                    String headName = headerList.get(i);
//                    if (name.equals(headName)){
//                        fieldsDto.setIndex(i);
//                    }
//                }
//            }
//
//            // 组装exam_detail数据
//            Long schoolId = tbTask.getSchoolId();
//            Long printPlanId = tbTask.getPrintPlanId();
//            List<ExamPrintPlan> examPrintPlanList = examPrintPlanService.list(new QueryWrapper<ExamPrintPlan>().lambda().eq(ExamPrintPlan::getSchoolId,schoolId).eq(ExamPrintPlan::getId,printPlanId));
//            if (examPrintPlanList.size() != 1){
//                throw ExceptionResultEnum.ERROR.exception("没有找到对应的考试计划");
//            }
//            String printPlanName = examPrintPlanList.get(0).getName();
//            int examPlaceIndex = fieldsDtoList.stream().filter(e -> "examPlace".equals(e.getCode())).map(FieldsDto::getIndex).collect(Collectors.toList()).get(0);
//
//            // 组装exam_detail_course数据
//
//            // 组装exam_student数据


        return null;
    }
}
